﻿using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace XdgIdei {
    public class ValidationFormatRuleProxy : DiscreetRuleBaseProxy {

        public ValidationRule Rule { get; set; }
        public Style StyleToApply { get; set; }

        protected override Style EvaluateCondition(object sourceDataObject, object sourceDataValue) {
            MyClass source = (MyClass)sourceDataObject;

            if (sourceDataValue == null)
                return null;

            ValidationResult result = Rule.Validate(sourceDataValue, System.Globalization.CultureInfo.CurrentCulture);

            ColumnError error = new ColumnError {
                Column = Parent.Column,
                Result = result
            };
            source.Errors.Remove(error);
            if(!result.IsValid)
                source.Errors.Add(error);

            return result.IsValid ? null : StyleToApply;
        }
    }
}
